#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *prosiri(char *tekst, char **skr, char **puni, int n)
{
    char *novi = NULL;
    int i, j, t;
    int k, m = strlen(tekst);
    novi = (char *)malloc( (m+1)*sizeof(char) );
    strcpy(novi, tekst);

    for (i = 0; i < n; ++i)
    {
        k = strlen(skr[i]);
        for (j = 0; j <= m - k; ++j)
            if (!strncmp(skr[i], novi+j, k))
            {
                int pomak = strlen(puni[i])-k;
                novi = (char *)realloc(novi, (m+pomak+1)*sizeof(char));

                for (t = m; t >= j+k; t--)
                    novi[t+pomak] = novi[t];
                m += pomak;

                for (t = 0; t < strlen(puni[i]); t++)
                    novi[j+t] = puni[i][t];
                j += strlen(puni[i]);
            }
    }

    return novi;
}

int main()
{
    char *skr[] = {"npr.", "tj.", "akko", "sl.", "dr.", "itd", "str.", "v.", "usp."};
    char *puni[] = {"na primjer", "to jest", "ako i samo ako", "slicno",
                    "doktor", "i tako dalje", "stranica", "vidi", "usporedi"};
    char *tekst = "npr. usp. dokaz str. 123 itd";
    int n = sizeof(skr) / sizeof(char *);

    char *prosiren = prosiri(tekst, skr, puni, n);
    printf("%s\n", prosiren);

    free(prosiren);
    return 0;
}
