#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *objasni(char *tekst, char **akronim, char **naziv, int n)
{
    char *novi = NULL;
    int i, j, t;
    int k, m = strlen(tekst);
    novi = (char *)malloc( (m+1)*sizeof(char) );
    strcpy(novi, tekst);

    for (i = 0; i < n; ++i)
    {
        k = strlen(akronim[i]);
        for (j = 0; j <= m - k; ++j)
            if (!strncmp(akronim[i], novi+j, k))
            {
                int pomak = strlen(naziv[i])-k;
                novi = (char *)realloc(novi, (m+pomak+1)*sizeof(char));

                for (t = m; t >= j+k; t--)
                    novi[t+pomak] = novi[t];
                m += pomak;

                for (t = 0; t < strlen(naziv[i]); t++)
                    novi[j+t] = naziv[i][t];
                j += strlen(naziv[i]);
            }
    }

    return novi;
}

int main()
{
    char *akronim[] = {"SAD", "UN", "UK", "EU"};
    char *naziv[] = {"Sjedinjene Americke Drzave", "Ujedinjeni Narodi",
                    "Ujedinjeno Kraljevstvo", "Europska Unija"};
    char *tekst = "SAD i EU su dogovorile suradnju.";
    int n = sizeof(akronim) / sizeof(char *);

    char *prosiren = objasni(tekst, akronim, naziv, n);
    printf("%s\n", prosiren);

    free(prosiren);
    return 0;
}
