#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *artikli(char *tekst, char **kod, char **opis, int n)
{
    char *novi = NULL;
    int i, j, t;
    int k, m = strlen(tekst);
    novi = (char *)malloc( (m+1)*sizeof(char) );
    strcpy(novi, tekst);

    for (i = 0; i < n; ++i)
    {
        k = strlen(kod[i]);
        for (j = 0; j <= m - k; ++j)
            if (!strncmp(kod[i], novi+j, k))
            {
                int pomak = strlen(opis[i])-k;
                novi = (char *)realloc(novi, (m+pomak+1)*sizeof(char));

                for (t = m; t >= j+k; t--)
                    novi[t+pomak] = novi[t];
                m += pomak;

                for (t = 0; t < strlen(opis[i]); t++)
                    novi[j+t] = opis[i][t];
                j += strlen(opis[i]);
            }
    }

    return novi;
}

int main()
{
    char *kod[] = {"A001", "A002", "A003", "A004", "A005", "A006"};
    char *opis[] = {"hrana za macke", "hrana za pse", "banane",
                    "kruh", "secer", "kava"};
    char *tekst = "Vodeci izvozni proizvodi Paname su A003, A005 i A006.";
    int n = sizeof(kod) / sizeof(char *);

    char *prosiren = artikli(tekst, kod, opis, n);
    printf("%s\n", prosiren);

    free(prosiren);
    return 0;
}
